{$N+}
program Mandelbrot;
uses
        Graph, graphs, Crt;
type
        Complex = record
                Real : Real;
                Imag : Real;
        end;
const
        MaxIter = 30;
        BailOut = 16;
var
        Working, Working2, Backup : Complex;
        X, Y, Count : Integer;
        cancel : Boolean;
procedure ComplexSquare(a : Complex; var result : Complex);
begin
        Result.Real := (Sqr(a.Real) - Sqr(a.Imag));
        Result.Imag := 2 * a.Real * a.Imag;
end;
procedure ComplexAdd(a, b : Complex; var result : Complex);
begin
        Result.Real := a.Real + b.Real;
        Result.Imag := a.Imag + b.Imag;
end;
procedure ToComplex(a, b : Real; var result : Complex);
begin
        Result.Real:=a;
        Result.Imag:=b;
end;
begin
        cancel := False;
        Randomize;
        open_graph;
        for  Y := - GetMaxY div 2  to  0  do
                for  X := -GetMaxX div 2  to GetMaxX div 2  do
                begin
                        Count := 0;
                        ToComplex(X / 200, Y / 200, Backup);
                        ToComplex(0, 0, Working);
                        while  ((Sqr(Working.Real) + Sqr(Working.Imag)) < BailOut) 
                                and (Count < MaxIter)  do
                        begin
                                Working2 := Working;
                                ComplexSquare(Working2, Working);
                                ComplexAdd(Working, Backup, Working2);
                                Working := Working2;
                                Inc(Count);
                                if  KeyPressed  then
                                begin
                                        ReadKey;
                                        Count := MaxIter;
                                        X := 161;
                                        Y := 101;
                                        cancel := True;
                                end;
                        end;
                        if  Count <> MaxIter  then
                        begin
                                PutPixel(GetMaxX div 2 + X, GetMaxY div 2 + Y, 
                                        255 - ((Count mod 254) + 2));
                                PutPixel(GetMaxX div 2 + X, GetMaxY div 2 + Abs(Y), 
                                        255 - ((Count mod 254) + 2));
                        end
                        else
                        begin
                                PutPixel(GetMaxX div 2 + X, GetMaxY div 2 + Y, 0);
                                PutPixel(GetMaxX div 2 + X, GetMaxY div 2 + Abs(Y), 0);
                        end;
                        if  cancel  then  Exit;
                end;
        while  not KeyPressed  do
        begin
                SetPalette(Random(16), Random(16));
                Delay(50);
        end;
        ReadKey;
        close_graph;
end.
