program solid_tetrahedron;
uses
        Graph, Crt, graphs3d;
var
        theta : Real;
        P : projection;
type
        ShapeType=array[1..4] of record
                x, y, z : Integer
        end;
const
        s = 50;
        vert : ShapeType = ((x : 0; y : -s; z : 0),
                                                (x : 0; y :  0; z : s),
                                                (x : 0; y :  s; z : 0),
                                                (x : s; y :  0; z : 0));
procedure draw_poly(j, color : Word);
var
        xp, yp : array[1..3] of Integer;
        vertex : array[1..3] of PointType;
        i, k : Word;
begin
        i := 1;
        k := 1;
        repeat
                if  i<>j  then
                begin
                        project(P, vert[i].x, vert[i].y,  vert[i].z, 
                                0, 0, xp[k], yp[k]);
                        Inc(k);
                end;
                Inc(i);
        until  k = 4;
        for  i := 1  to  3  do
        begin
                vertex[i].x := xp[i] + GetMaxX div 2;
                vertex[i].y := GetMaxY div 2 - yp[i];
        end;
        SetFillStyle(SolidFill, color);
        FillPoly(3, vertex);
end;
procedure draw_tetra;
begin
        draw_poly(4, Black);
        draw_poly(2, White);
        draw_poly(1, LightGray);
        draw_poly(3, DarkGray);
end;
begin
        open_graph;
        theta := 0;
        compute_dimetric_matrix(theta, P);
        draw_tetra;
        ReadLn;
        theta := 0;
        repeat
                ClearViewPort;
                compute_dimetric_matrix(theta, P);
                draw_tetra;
                theta := theta + 1;
        until  theta >= 45;
        ReadLn;
        close_graph;
end.
